/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.awt.Color;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;
import de.matthiasmann.continuations.SuspendExecution;

public class GameItemWell extends GameItem {
   
   public GameItemWell() {
      this.name = "well";
      this.color = Color.BLUE;
      
      this.resources.register(ResourceType.WATER, new ResourceHolder(10000, 15000));
      
      this.spawn(new VirtualRunnable() {
         @Override
         public void run() throws SuspendExecution {
            while (true) {
               VirtualThread.sleep(1000);
               resources.get(ResourceType.WATER).put(Misc.random(10, 100));
            }
         }
      });
   }
   
   @Override
   public void onAdd() {
      super.onAdd();
      
      Game.WELL_GRID.put(this);
   }
   
   @Override
   public void onRemove() {
      super.onRemove();
      
      Game.WELL_GRID.remove(this);
   }
}
