/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;
import de.matthiasmann.continuations.SuspendExecution;

public class MoveAI implements VirtualRunnable {
   
   public static void moveTo(GameItem item, Vec2 dst) throws SuspendExecution {
      MoveAI mover = new MoveAI(item);
      mover.dst.set(dst);
      mover.run();
   }
   
   public final GameItem item;
   public final Vec2     dst;
   
   public MoveAI(GameItem item) {
      this.item = item;
      this.dst = new Vec2();
   }
   
   @Override
   public void run() throws SuspendExecution {
      
      Vec2 src = new Vec2(this.item.position);
      
      float distance = new Vec2(this.dst).sub(src).len();
      if (distance == 0.0f) {
         return;
      }
      
      // start moving...
      float travelled = 0.0f;
      while (travelled < distance) {
         travelled += this.item.speed * Game.TICK_DURATION;
         
         Vec2.lerp(Misc.clamp(travelled / distance), src, this.dst, this.item.position);
         
         // wait for next game tick
         VirtualThread.yield();
      }
      
      // reached destination 
   }
}
