/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import riven.virtualthreads.VirtualRunnable;
import de.matthiasmann.continuations.SuspendExecution;

public class ProjectileAI implements VirtualRunnable {
   public final GameItem item;
   public final Vec2     orientation;
   
   public ProjectileAI(GameItem item, Vec2 orientation) {
      this.item = item;
      this.orientation = orientation;
   }
   
   @Override
   public void run() throws SuspendExecution {
      
      Vec2 dst = new Vec2(this.orientation);
      dst.mul(this.item.speed);
      dst.add(this.item.position);
      
      MoveAI.moveTo(this.item, dst);
      
      // remove bullet from scene
      Game.removeItem(this.item);
   }
}
