/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

public class ResourceGroup {
   private final Map<ResourceType, ResourceHolder> mapping;
   
   public ResourceGroup() {
      this.mapping = new HashMap<ResourceType, ResourceHolder>();
   }
   
   public void register(ResourceType type, ResourceHolder holder) {
      if (this.mapping.containsKey(type)) {
         throw new IllegalStateException();
      }
      this.mapping.put(type, holder);
   }
   
   public ResourceHolder get(ResourceType type) {
      ResourceHolder holder = this.mapping.get(type);
      if (holder == null) {
         throw new NoSuchElementException("type: " + type.name());
      }
      return holder;
   }
   
   @Override
   public String toString() {
      return this.mapping.toString();
   }
   
   //
   
   public static int transfer(ResourceType type, ResourceGroup src, ResourceGroup dst) {
      return ResourceHolder.transfer(src.get(type), dst.get(type));
   }
   
   public static int transfer(ResourceType type, ResourceGroup src, ResourceGroup dst, int max) {
      return ResourceHolder.transfer(src.get(type), dst.get(type), max);
   }
}