/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.awt.Color;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;
import de.matthiasmann.continuations.SuspendExecution;

public class ShootingAI implements VirtualRunnable {
   public final GameItem item;
   
   public ShootingAI(GameItem item) {
      this.item = item;
   }
   
   @Override
   public void run() throws SuspendExecution {
      
      long[] loadDelays = new long[] { 100, 100, 100, 100, 100, 800 };
      
      for (int i = 0; true; i++) {
         if (this.item.shootingTarget == null) {
            // wait for next target
            VirtualThread.sleep(1000);
            continue;
         }
         
         // bullet load time
         long loadDelay = loadDelays[i % loadDelays.length];
         VirtualThread.sleep(loadDelay);
         
         Vec2 target = new Vec2(this.item.shootingTarget);
         Vec2 orientation = new Vec2(target).sub(this.item.position).norm();
         
         // create the bullet
         final GameItem bullet = new GameItem();
         bullet.name = "bullet";
         bullet.color = Color.RED;
         bullet.speed = 250f;
         bullet.position.set(this.item.position);
         
         // start moving bullet
         new VirtualThread(new ProjectileAI(bullet, orientation)).start();
         
         Game.addItem(bullet);
      }
   }
}