/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

public class Vec2 {
   public float x, y;
   
   public Vec2() {
      this(0.0f, 0.0f);
   }
   
   public Vec2(Vec2 pos) {
      this(pos.x, pos.y);
   }
   
   public Vec2(float x, float y) {
      this.x = x;
      this.y = y;
   }
   
   //
   
   public Vec2 set(Vec2 pos) {
      return this.set(pos.x, pos.y);
   }
   
   public Vec2 set(float x, float y) {
      this.x = x;
      this.y = y;
      return this;
   }
   
   //
   
   public Vec2 add(Vec2 pos) {
      return this.add(pos.x, pos.y);
   }
   
   public Vec2 add(float x, float y) {
      this.x += x;
      this.y += y;
      return this;
   }
   
   //
   
   public Vec2 sub(Vec2 pos) {
      return this.sub(pos.x, pos.y);
   }
   
   public Vec2 sub(float x, float y) {
      this.x -= x;
      this.y -= y;
      return this;
   }
   
   //
   
   public Vec2 mul(Vec2 pos) {
      return this.mul(pos.x, pos.y);
   }
   
   public Vec2 mul(float s) {
      return this.mul(s, s);
   }
   
   public Vec2 mul(float x, float y) {
      this.x *= x;
      this.y *= y;
      return this;
   }
   
   //
   
   public Vec2 div(Vec2 pos) {
      return this.div(pos.x, pos.y);
   }
   
   public Vec2 div(float s) {
      //return this.div(s, s);
      return this.mul(1.0f / s);
   }
   
   public Vec2 div(float x, float y) {
      this.x /= x;
      this.y /= y;
      return this;
   }
   
   //
   
   public float len2() {
      return (this.x * this.x) + (this.y * this.y);
   }
   
   public float len() {
      return (float) Math.sqrt(this.len2());
   }
   
   public Vec2 norm() {
      return this.mul(1.0f / this.len());
   }
   
   public float angle() {
      return (float) Math.atan2(this.y, this.x);
   }
   
   //
   
   public static Vec2 lerp(float ratio, Vec2 a, Vec2 b) {
      return lerp(ratio, a, b, new Vec2());
   }
   
   public static Vec2 lerp(float ratio, Vec2 a, Vec2 b, Vec2 dst) {
      dst.x = Misc.lerp(ratio, a.x, b.x);
      dst.y = Misc.lerp(ratio, a.y, b.y);
      return dst;
   }
   
   //
   
   @Override
   public String toString() {
      return this.x + ", " + this.y;
   }
}
