package riven.virtualthreads.test;

import riven.virtualthreads.VirtualProcessor;
import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;
import riven.virtualthreads.util.VirtualTrigger;
import de.matthiasmann.continuations.SuspendExecution;

/*
 * Created on Nov 21, 2010
 */

public class VirtualThreadTest {
   public static void main(String[] args) throws Throwable {
      
      VirtualProcessor proc = new VirtualProcessor();
      
      VirtualThread thread = new VirtualThread() {
         @Override
         public void run() throws SuspendExecution {
            
            final VirtualTrigger trigger = new VirtualTrigger();
            
            // fire the trigger after 5s
            this.spawn(new VirtualRunnable() {
               @Override
               public void run() throws SuspendExecution {
                  VirtualThread.sleep(5000);
                  System.out.println("fire!");
                  trigger.fire(); // here
               }
            });
            
            System.out.println("wait for it.....");
            // fire the trigger after 8s
            trigger.await(8000);
            System.out.println("done waiting, either due to a timeout, or due to a fired trigger");
         }
      };
      thread.start(proc);
      
      do {
         Thread.sleep(1);
      }
      while (proc.tick(System.nanoTime() / 1000000L));
      
      System.out.println("Done.");
   }
}